Circle = {}
Circle.__index = Circle

function Circle.create(x,y,max_radius,speed)
	local new_circle = {
		x = x,
		y = y,
		radius = 0,
		speed = speed,
		is_growing = true
	};
	setmetatable(new_circle, Circle);
	return new_circle;
end

function Circle:reverse()
	self.is_growing = not self.is_growing;
end

function Circle:update(dt)
	local delta = self.is_growing and 1 or -1;
	
	self.radius = self.radius + delta * self.speed * dt;
	self.radius = math.max(0,self.radius);
	
	if(self.radius == 0) then
		self:reverse();
	end
end

function Circle:isCollided(c)
	if(self.is_growing == false) then
		return false;
	end
	
	local distance_sqr = (self.x - c.x) * (self.x - c.x) + (self.y - c.y) * (self.y - c.y);
	local radius_sqr = (self.radius + c.radius) * (self.radius + c.radius);
	
	return (distance_sqr <= radius_sqr);
end