Title = {
	maxAlpha = 1000,
	alpha = 1000,
	fadeSpeed = 200,
	is_growing = false,
	current_screen = 1,
	
	fonts = {
		love.graphics.newFont(13),
		love.graphics.newFont(24),
		love.graphics.newFont(16),
	},
	
	screens = {
		{
			{ r = 255, g = 155, b = 55, x = 310, y = 220, font = 2, text = 'Music Circles' },
			{ r = 255, g = 255, b = 255, x = 20, y = 535, font = 1, text = 'made by Andrey Viktorov' },
			{ r = 150, g = 255, b = 150, x = 20, y = 560, font = 1, text = 'twitter : aviktorov' },
			{ r = 150, g = 255, b = 150, x = 20, y = 575, font = 1, text = 'mailto : andrey.viktorov@gmail.com' },
		},
		
		{
			{ r = 255, g = 155, b = 55, x = 310, y = 220, font = 2, text = 'Controls' },
			{ r = 255, g = 255, b = 150, x = 250, y = 270, font = 3, text = 'Left mouse button : create circle' },
			{ r = 255, g = 255, b = 150, x = 250, y = 290, font = 3, text = 'Right mouse button : clear' },
		},
	},
	
	update = function(dt)
		if(Title.isFinished()) then
			return;
		end
		
		local delta = Title.is_growing and 1 or -1;
		
		Title.alpha = Title.alpha + delta * Title.fadeSpeed * dt;
		Title.alpha = math.max(0,Title.alpha);
		Title.alpha = math.min(Title.maxAlpha,Title.alpha);
		
		if(Title.alpha == 0) then
			Title.current_screen = Title.current_screen + 1;
		end
		
		if(Title.alpha == 0 or Title.alpha == Title.maxAlpha) then
			Title.is_growing = not Title.is_growing
		end
	end,
	
	draw = function()
		if(Title.isFinished()) then
			return;
		end
		
		local screen = Title.screens[Title.current_screen];
		
		for i,text_params in ipairs(screen) do
			love.graphics.setColor(text_params.r,text_params.g,text_params.b,math.min(Title.alpha,255));
			love.graphics.setFont(Title.fonts[text_params.font]);
			love.graphics.print(text_params.text,text_params.x,text_params.y);
		end
	end,
	
	nextScreen = function()
		Title.is_growing = false;
		Title.alpha = math.min(Title.alpha,255);
	end,
	
	isFinished = function()
		return (Title.current_screen > #Title.screens);
	end
};

